'From Squeak3.6 of ''6 October 2003'' [latest update: #5429] on 19 May 2005 at 1:51:53 pm'!
Object subclass: #TrafficController
	instanceVariableNames: 'robots '
	classVariableNames: ''
	poolDictionaries: ''
	category: '341-6'!

!TrafficController methodsFor: 'as yet unclassified' stamp: 'mc 5/19/2005 13:51'!
addRobot: r atCollision: c
	robots ifNil: [robots_Set new].
	robots do: [:p | p first = r ifTrue: [ p at: 2 put: c. ^self ]].
	robots add: {r.c}.! !

!TrafficController methodsFor: 'as yet unclassified' stamp: 'mc 5/17/2005 14:36'!
bounce: u with: v
	|d dn diff vu vv uperp upar vperp vpar ru rv|

	d_v bounds center-(u bounds center).

	vu_u velocity.
	vv_v velocity.

	(d dotProduct: d) < 1e-4
		ifTrue: [d_d-vu-vv].
	
	d_d normalized.
	dn_d normal.

	upar_(d dotProduct: vu)*d.
	uperp_(dn dotProduct: vu)*dn.

	d_d*-1.
	vpar_(d dotProduct: vv)*d.
	vperp_(dn dotProduct: vv)*dn.

	u velocity: uperp + vpar.
	v velocity: vperp + upar.

	ru_self radius: u.
	rv_self radius: v.
	d_u bounds center - v bounds center.
	diff_ ru+rv-d r.
	d_d normalized.
	u bounds: (u bounds translateBy: d*diff/2).
	v bounds: (v bounds translateBy: d*diff/-2).! !

!TrafficController methodsFor: 'as yet unclassified' stamp: 'mc 5/19/2005 13:18'!
collisionWith: r do: block

	robots ifNil: [^self].
	robots do:[:s| 
		s first~=r ifTrue:[
            (self hits: s first with: r)
			ifTrue:[self bounce: s first with: r.
					s second value: r.
					block value: s first]]].
! !

!TrafficController methodsFor: 'as yet unclassified' stamp: 'mc 5/19/2005 12:53'!
deleteAll
	|r|
	r_robots.
	robots_nil.
	r ifNotNil: [r do: [:s| s first delete]].! !

!TrafficController methodsFor: 'as yet unclassified' stamp: 'mc 5/17/2005 14:35'!
hits: u with: v
	| diff |

	diff_(u bounds center - v bounds center) r.
	^(diff < ((self radius: u)+(self radius: v))).! !

!TrafficController methodsFor: 'as yet unclassified' stamp: 'mc 5/17/2005 14:35'!
radius: r

	^ { r bounds width. r bounds height } min/2! !

!TrafficController methodsFor: 'as yet unclassified' stamp: 'mc 5/19/2005 13:23'!
removeRobot: r

	robots ifNil: [^self].
	robots_robots select: [:p| p first ~= r]..! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

TrafficController class
	instanceVariableNames: 'control '!

!TrafficController class methodsFor: 'as yet unclassified' stamp: 'mc 5/15/2005 21:12'!
control
	control ifNil: [control_TrafficController new].
	^control! !
